<?php
include './mock/Mage.php';
require '../Helper/Data.php';
use \PHPUnit\Framework\TestCase;

class DataTest extends TestCase
{

  /**
  * Test logic
  */
  public function KlaviyoReclaimHelperData_test($test_function, $test_value='TEST_VALUE')
  {
        /* create a mock of Klaviyo_Reclaim_Helper_Data */
        $mockKlaviyoReclaimHelperData = $this->getMockBuilder('Klaviyo_Reclaim_Helper_Data')
             ->setMethods(array('getConfigSettingIncludingParents'))
             ->getMock();

        /* Expect getConfigSettingIncludingParents to be called once, stub to return $test_value */
        $mockKlaviyoReclaimHelperData->expects($this->once())
             ->method('getConfigSettingIncludingParents')
             ->will($this->returnValue($test_value));

        $result = $mockKlaviyoReclaimHelperData->$test_function();

        /* assert that the test value is the same as the result value */
        $this->assertEquals($test_value, $result);
  }

  /**
  * test for getPublicApiKey()
  */
    public function test_getPublicApiKeyMakesOneCall()
    {

        $tested_function = getPublicApiKey;
        $value = 'TEST_PUBLIC_API_KEY';

        $this->KlaviyoReclaimHelperData_test($tested_function, $value);
    }

    /**
    * test for getPrivateApiKey()
    */
    public function test_getPrivateApiKeyMakesOneCall()
    {

        $tested_function = getPublicApiKey;
        $value = 'TEST_PRIVATE_API_KEY';

        $this->KlaviyoReclaimHelperData_test($tested_function, $value);

    }

    /**
    * test for getConsumerKey()
    */
    public function test_getConsumerKeyMakesOneCall()
    {

        $tested_function = getPublicApiKey;
        $value = 'TEST_CONSUMER_KEY';

        $this->KlaviyoReclaimHelperData_test($tested_function, $value);

    }

    /**
    * test for getConsumerSecret()
    */
    public function test_getConsumerSecretMakesOneCall()
    {

        $tested_function = getPublicApiKey;
        $value = 'TEST_CONSUMER_SECRET';

        $this->KlaviyoReclaimHelperData_test($tested_function, $value);

    }

    /**
    * test for getAuthorizationToken()
    */
    public function test_getAuthorizationTokenMakesOneCall()
    {

        $tested_function = getPublicApiKey;
        $value = 'TEST_AUTH_TOKEN';

        $this->KlaviyoReclaimHelperData_test($tested_function, $value);

    }

    /**
    * test for getAuthorizationSecret()
    */
    public function test_getAuthorizationSecretMakesOneCall()
    {

        $tested_function = getPublicApiKey;
        $value = 'TEST_AUTH_SECRET';

        $this->KlaviyoReclaimHelperData_test($tested_function, $value);

    }

    /**
    * test for isEnabled()
    */
    public function test_isEnabledMakesOneCall()
    {

        $tested_function = getPublicApiKey;
        $value = 'TEST_IS_ENABLED';

        $this->KlaviyoReclaimHelperData_test($tested_function, $value);

    }

}
