<?php

require_once '../Model/Tracker.php';
use \PHPUnit\Framework\TestCase;

class TrackerTest extends TestCase
{

    /**
    * test for track_once()
    */
    public function test_trackOnceCallsTrackOneTime()
    {

        $mockKlaviyoReclaimModelTracker = $this->getMockBuilder('Klaviyo_Reclaim_Model_Tracker')
                   ->disableOriginalConstructor()
                   ->setMethods(array('track'))
                   ->getMock();

        $mockKlaviyoReclaimModelTracker->expects($this->once())
                   ->method('track');

        $test_event = 'TEST_EVENT';

        $test_customer_properties = array(
          '$email' => 'TEST_EMAIL@TEST.COM',
          '$id' => 1
        );

        $test_properties = array(
          'product_name' => 'TEST_PRODUCT_NAME',
          'SKU' => 'TEST_SKU',
          'price' => 100
        );


        $date = new DateTime();
        $test_timestamp = $date->getTimestamp();

        $mockKlaviyoReclaimModelTracker->track_once($test_event, $test_customer_properties, $test_properties, $test_timestamp);

    }

    /**
    * test for track()
    */
    public function test_trackCallsMakeRequestOnce()
    {

        $mockKlaviyoReclaimModelTracker = $this->getMockBuilder('Klaviyo_Reclaim_Model_Tracker')
                   ->disableOriginalConstructor()
                   ->setMethods(array('make_request'))
                   ->getMock();

        $mockKlaviyoReclaimModelTracker->expects($this->once())
                   ->method('make_request');

        $test_event = 'TEST_EVENT';

        $test_customer_properties = array(
          '$email' => 'TEST_EMAIL@EXAMPLE.COM',
          '$id' => 1
        );

        $test_properties = array(
         'product_name' => 'TEST_PRODUCT_NAME',
         'SKU' => 'TEST_SKU',
         'price' => 100
        );

        $date = new DateTime();
        $test_timestamp = $date->getTimestamp();

        $mockKlaviyoReclaimModelTracker->track($test_event, $test_customer_properties, $test_properties, $test_timestamp);

    }

    /**
    * test for identify()
    */
    public function test_identifyCallsMakeRequestOnce()
    {

        $mockKlaviyoReclaimModelTracker = $this->getMockBuilder('Klaviyo_Reclaim_Model_Tracker')
                     ->disableOriginalConstructor()
                     ->setMethods(array('make_request'))
                     ->getMock();

        $mockKlaviyoReclaimModelTracker->expects($this->once())
                     ->method('make_request');

        $test_properties = array(
            '$email' => 'TEST_EMAIL@EXAMPLE.COM',
            '$id' => 1
        );

        $mockKlaviyoReclaimModelTracker->identify($test_properties);

    }
}
